#include "ZTM_DEF.h"

int tot_tex_coord;
float texture_coord[20000][2];

int generate_texture_list(string inString, _MOD_DATA * model)
{
    if (inString=="None") return -1;
    for (int i=0; i<model->TOT_TEXT; i++)
    {
        if (inString == TextureArray[i]) return i;
    }
    TextureArray[model->TOT_TEXT] = inString;
    model->TOT_TEXT++;
    return model->TOT_TEXT-1;
}

int sort_faces(string inString, vPDATA * t_PDATA, POLYGON * bufPol, int index, int total_verts)
{
            string f1, f2, f3;
            char bufferChar[128]={}; //Don't ask, I'm more used to C than C++, so just went "fuck it"....
            int i = 0;
            for (i=0; i<128; i++)
            {
                if (inString[i]=='/') {i++; break;}
                bufferChar[i]=inString[i];
            }
            f1 = bufferChar;
            int charPtr=0;            char bufferChar2[128]={};            f2 = "";
            for (i=i; i<128; i++)
            {
                if (inString[i]=='/') {i++; break;}
                bufferChar2[charPtr]= inString[i];
                charPtr++;
            }
            f2 = bufferChar2;
            charPtr=0; char bufferChar3[128]={}; f3 = "";
            for (i=i; i<128; i++)
            {
                if (inString[i]=='/') {i++; break;}
                bufferChar3[charPtr]=inString[i];
                charPtr++;
            }
            f3=bufferChar3;

  int i1, i2; //, i3;
  if (f1 != "")   i1 = std::stoi(f1) - 1;
  else (i1 = 0);
  if (f2 != "") i2 = std::stoi(f2) - 1;
  else (i2 = 0);
 /* if (f3 != "") i3 = std::stoi(f3) - 1;
  else (i3 = 0);*/


  bufPol->Vertices[index]=i1-total_verts;

  return i2;
}


/****
*Main function to read the OBJ file
*Param : Obj file, upscale value (integer), your model data (_MOD_DATA) and boolean if it's a base model
*****/
bool load_OBJ_to_mesh(ifstream *file, vector3 scalefactor, _MOD_DATA * model, bool is_base_model)
{
    string line;
    int pointer = 0;
    int textpointer = -1;
    int bufTotalVerts = 0;
    int MeshPtr = -1;

    tot_tex_coord=0;

    if (!file->is_open()) return false;
    file->seekg(pointer, ios::beg);

    vPDATA * o_PDATA;

    while(!file->eof())
    {
        getline(*file, line);
        if ((line[0] == 'o' && line[1] == ' ') || (line[0]== 'g'))
        {
            if (MeshPtr >= 0) bufTotalVerts += model->pol[MeshPtr].nbPoint;
            MeshPtr++;
            model->pol[MeshPtr].nbPoint=0; model->pol[MeshPtr].nbPolygon=0;
            model->pol[MeshPtr].pntbl = new POINT[20000];            model->pol[MeshPtr].pltbl = new POLYGON[20000];            model->pol[MeshPtr].attbl = new ATTR[20000];
            model->pol[MeshPtr].vntbl = new VECTOR[20000];
            o_PDATA = &model->pol[MeshPtr];

            stringstream NameSS(line);            string buffer;            getline(NameSS, buffer, ' ');            NameSS >> buffer;
            cout << "\nMESH NAME : " << buffer << "\n";
            PdataName[MeshPtr] = buffer;
        }
        else if (line[0] == 'v' && line[1] == ' ')
        {
            stringstream PointSS(line);
            string uselessbuffer;
            getline(PointSS, uselessbuffer, ' ');
            string sx = ""; string sy = ""; string sz = "";
            PointSS >> sx >> sy >> sz;

            float fx = std::stof(sx);            float fy = std::stof(sy);            float fz = std::stof(sz);
            int ix, iy, iz;
            ix = fx*65536.0*scalefactor.x; iy = fy*65536.0*scalefactor.y; iz=fz*65536.0*scalefactor.z;

            o_PDATA->pntbl[o_PDATA->nbPoint][0] = ix;
            o_PDATA->pntbl[o_PDATA->nbPoint][1] = iy;
            o_PDATA->pntbl[o_PDATA->nbPoint][2] = iz;
            o_PDATA->nbPoint++;
        }
        else if (line[0]== 'v' && line[1]== 'n')  //Could be removed since we recalculate all the normals
        {
        }
        else if (line[0]== 'm') //material library, not implemented for now
        {

        }
        else if (line[0]== 's')  //Shader? Not implemented
        {

        }
        else if (line[0]== 'v' && line[1]== 't')
        {
            stringstream TCoord(line);         string bufferStr;
            getline(TCoord, bufferStr, ' ');
            string tc[2] = {""};
            TCoord >> tc[0] >> tc[1];
            texture_coord[tot_tex_coord][0] = std::stof(tc[0]);
            texture_coord[tot_tex_coord][1] = std::stof(tc[1]);
            tot_tex_coord++;
        }
        else if (line[0]=='u' && line[1]=='s' && line[2]=='e' && line[3]=='m' && line[4]=='t' && line[5]=='l') //Yeah, I know we all got it after the 2 letters, but just in case some weird Obj format popup...
        {
            stringstream MtlSS(line);         string bufferStr;
            getline(MtlSS, bufferStr, ' ');
            string mtlName = {""};
            MtlSS >> mtlName;
            textpointer=generate_texture_list(mtlName, model);

        }
        else if (line[0] == 'f' && line[1] == ' ')
        {
            stringstream FaceSS(line);
            string bufferStr;
            getline(FaceSS, bufferStr, ' ');
            string p[4];
            FaceSS >> p[0] >> p[1] >> p[2] >> p[3];
            if (p[3]=="") {p[3]=p[2]; /*cout << "Triangle detected. Merging point 4 with point 3\n";*/}

            POLYGON bufPol;
            int texC[4];
            /*for (unsigned int f=0; f<4; f++)
            {texC[f]=sort_faces(p[f], o_PDATA, &bufPol, f, bufTotalVerts);}*/


            sort_faces(p[3], o_PDATA, &bufPol, 0, bufTotalVerts);
            sort_faces(p[2], o_PDATA, &bufPol, 1, bufTotalVerts);
            sort_faces(p[1], o_PDATA, &bufPol, 2, bufTotalVerts);
            sort_faces(p[0], o_PDATA, &bufPol, 3, bufTotalVerts);

            //int MinX = texC[0], MinY = texC[0];
            /*unsigned short bufVertices[4];
            if (p[3]!=p[2])
            {
                for (int i=0; i<4; i++) bufVertices[i]=bufPol.Vertices[i];
                for (int i=0; i<4; i++)
                {
                    if ((-0.3f <= texture_coord[texC[i]][X] <= 0.3f) && (texture_coord[texC[i]][Y] >= 0.7f))
                    {
                        unsigned int v=i;
                        bufPol.Vertices[0]=bufVertices[v];
                        v++; if (v>=4)v=0;
                        bufPol.Vertices[1]=bufVertices[v];
                        v++; if (v>=4)v=0;
                        bufPol.Vertices[2]=bufVertices[v];
                        v++; if (v>=4)v=0;
                        bufPol.Vertices[3]=bufVertices[v];
                    }
                }
            }*/

            /*if (texture_coord[texC[1]][0] < texture_coord[MinX]) MinX=texC[1];
            if (texture_coord[texC[1]][1] < texture_coord[MinY]) MinY=texC[1];
            if (texture_coord[texC[2]][0] < texture_coord[texC[0][0]]) MinX=texC[1];
            if (texture_coord[texC[2][1]] < texture_coord[texC[0][1]]) MinY=texC[1];*/

            o_PDATA->pltbl[o_PDATA->nbPolygon]=bufPol;

            if (textpointer != -1) {
                    unsigned short bufTxtno = (unsigned short)(textpointer);
                     o_PDATA->attbl[o_PDATA->nbPolygon]=ATTRIBUTE(Single_Plane, SORT_MAX, bufTxtno, No_Palet, No_Gouraud,Window_In|MESHoff|HSSon|ECdis|CL32KRGB,sprNoflip,No_Option|UseNearClip);}
            else
                {o_PDATA->attbl[o_PDATA->nbPolygon]=ATTRIBUTE(Single_Plane, SORT_MAX, 0, No_Palet, No_Gouraud,Window_In|MESHoff|HSSon|ECdis|CL32KRGB,sprNoflip,No_Option|UseNearClip);}
            o_PDATA->nbPolygon++;
        }
        pointer++;
    }

    file->clear();

    model->TOTAL_MESH=MeshPtr + 1;
    for (unsigned i = 0; i<model->TOTAL_MESH; i++)
    {
        RECALCULATE_NORMALS(&model->pol[i]);
        VECTOR_NORMAL(&model->pol[i]);
    }


    return true;
}



void clearMDATA(_MOD_DATA * model)
{
    for (int i=0; i<model->TOT_TEXT; i++)
    {
        TextureArray[i]="";
        TextureSpecialAttribute[i]=0;
    }
    model->TOT_TEXT=0;
    model->TEXT_SIZE=0;
    model->TOTAL_MESH=0;
    model->PDATA_SIZE=0;
}

#define vPDATA_SIZE 24
void generateMDATA(_MOD_DATA * model)
{
    _BB_Hitbox boundaries;
    boundaries.MinValue.x = 2147483647; boundaries.MinValue.y = 2147483647; boundaries.MinValue.z = 2147483647;
    boundaries.MaxValue.x = -2147483647;  boundaries.MaxValue.y = -2147483647;  boundaries.MaxValue.z = -2147483647;
    for (int i=0; i<model->TOTAL_MESH; i++)
    {

        model->PDATA_SIZE += vPDATA_SIZE;
        model->PDATA_SIZE += (model->pol[i].nbPoint*sizeof(POINT));
        model->PDATA_SIZE += (model->pol[i].nbPolygon*sizeof(POLYGON));
        model->PDATA_SIZE += (model->pol[i].nbPolygon*sizeof(ATTR));
        model->PDATA_SIZE += (model->pol[i].nbPoint*sizeof(VECTOR));

       _BB_Hitbox tmpBB;
       createLocalAABB(&model->pol[i], &tmpBB);

       if (tmpBB.MaxValue.x > boundaries.MaxValue.x) boundaries.MaxValue.x = tmpBB.MaxValue.x;
       if (tmpBB.MaxValue.y > boundaries.MaxValue.y) boundaries.MaxValue.y = tmpBB.MaxValue.y;
       if (tmpBB.MaxValue.z > boundaries.MaxValue.z) boundaries.MaxValue.z = tmpBB.MaxValue.z;

       if (tmpBB.MinValue.x < boundaries.MinValue.x) boundaries.MinValue.x = tmpBB.MinValue.x;
       if (tmpBB.MinValue.y < boundaries.MinValue.y) boundaries.MinValue.y = tmpBB.MinValue.y;
       if (tmpBB.MinValue.z < boundaries.MinValue.z) boundaries.MinValue.z = tmpBB.MinValue.z;

    }

    model->Origin = ReturnBBCenter(&boundaries);
    model->Length.x = (boundaries.MaxValue.x-boundaries.MinValue.x)/2;
    model->Length.y = (boundaries.MaxValue.y-boundaries.MinValue.y)/2;
    model->Length.z = (boundaries.MaxValue.z-boundaries.MinValue.z)/2;

}

void deleteCol(CDATA * col)
{
    delete [] col->cotbl;
    col->nbCo=0;
}

void deleteObj(vPDATA * pol)
{
        delete [] pol->pntbl;
        delete [] pol->pltbl;
        delete [] pol->attbl;
        delete [] pol->vntbl;
        pol->nbPoint=0;
        pol->nbPolygon=0;
}

/**No malloc, just static arrays for now (for quick testing)**/
/**TODO : Add malloc**/
/**TODO : Add normal LUT **/
#define Max_Normals (162)

normArr normLUT[] =
{
    #include "anorms.h"
};

/*
int checkSign(int a, int b)
{
    return (a < b) - (b < a);
}*/

/**Sign patch : since squared distance diregard signs, we need to check to make sure the signs are the same**/
bool CheckSigns(normArr a, normArr b)
{
    if ((a[X]<0 && b[X]>0) || (b[X]<0 && a[X]>0)) return false;
    if ((a[Y]<0 && b[Y]>0) || (b[Y]<0 && a[Y]>0)) return false;
    if ((a[Z]<0 && b[Z]>0) || (b[Z]<0 && a[Z]>0)) return false;
    return true;
}
Uint8 normalLookUp(VECTOR curVector)
{
    Uint8  bestRes = 0;
    //float   bestDist[XYZ] = {65535.0};
    float   bestDist = 65535.0;

    normArr curNormal;
    curNormal[X]=toFLOAT(curVector[X]);
    curNormal[Y]=toFLOAT(curVector[Y]);
    curNormal[Z]=toFLOAT(curVector[Z]);

    for (Uint32 i=0; i<Max_Normals; i++)
    {

        float dist = sqrt(pow(curNormal[X]-normLUT[i][X], 2) + pow(curNormal[Y]-normLUT[i][Y], 2) + pow(curNormal[Z]-normLUT[i][Z], 2));

        if ((dist) < (bestDist))
        {
            bestDist=dist;
            bestRes=i;
        }
    }
    //cout << " " << (Uint16)bestRes << " ";

    return bestRes;
}

void fixAnimationData(_MOD_DATA * baseModel, _MOD_DATA * kfModel)
{
    for (unsigned int i=0; i<kfModel->TOTAL_MESH; i++)
    {
        for (unsigned int ii=0; ii<kfModel->pol[i].nbPolygon; ii++)
        {
            for (unsigned int j=0; j<4; j++)
                kfModel->pol[i].pltbl[ii].Vertices[j]=baseModel->pol[i].pltbl[ii].Vertices[j];
        }
        RECALCULATE_NORMALS(&kfModel->pol[i]);
    }
}
void compareAnimationData(_MOD_DATA * baseModel, _MOD_DATA * kfModel, unsigned int FrameID)
{
    fixAnimationData(baseModel, kfModel);
    unsigned int tot_vertices=0; unsigned int tot_normals=0;
    for (unsigned int i=0; i<kfModel->TOTAL_MESH; i++)
    {
        for (unsigned int ii=0; ii<kfModel->pol[i].nbPoint; ii++)
        {
            for (unsigned int j=0; j<3; j++)
            {
                baseModel->animation[FrameID].cVert[tot_vertices][j]=
                (Sint16)(kfModel->pol[i].pntbl[ii][j]/128);
            }
                tot_vertices++;
        }
    }
    for (unsigned int i=0; i<kfModel->TOTAL_MESH; i++)
    {
        for (unsigned int ii=0; ii<kfModel->pol[i].nbPolygon; ii++)
        {
            /*for (unsigned int j=0; j<3; j++)
            {
                baseModel->animation[FrameID].cNorm[tot_normals][j]=
                (Sint16)(kfModel->pol[i].pltbl[ii].norm[j]/16);
            }*/
            baseModel->animation[FrameID].cNorm[tot_normals]=
            (Uint8)(normalLookUp(kfModel->pol[i].pltbl[ii].norm));

                tot_normals++;
        }
    }
}



void writeAnim(ofstream * file, _MOD_DATA * baseModel, unsigned int FrameID)
{
    int bSint32 = swap_endian_sint(FrameID);
    file->write((char*)&bSint32, sizeof(int));
    file->write((char*)&bSint32, sizeof(int));
    unsigned int tot_vertices=0, tot_normals=0;
    for (unsigned int i=0; i< baseModel->TOTAL_MESH; i++ )
    {
        for (unsigned int ii=0; ii<(baseModel->pol[i].nbPoint); ii++)
        {
            for (unsigned int j=0; j<3; j++)
            {
                short bSint16 = swap_endian_sshort(baseModel->animation[FrameID].cVert[tot_vertices][j]);
                file->write((char*)&bSint16, sizeof(short));
            }tot_vertices++;
        }
    }
    while (tot_vertices%2 !=0)
    {
        file->write((char*)(&bSint32), sizeof(short));
        tot_vertices++;
    }

    for (unsigned int i=0; i< baseModel->TOTAL_MESH; i++ )
    {
        for (unsigned int ii=0; ii<(baseModel->pol[i].nbPolygon); ii++)
        {
            /*for (unsigned int j=0; j<3; j++)
            {
                short bSint16 = swap_endian_sshort(baseModel->animation[FrameID].cNorm[tot_normals][j]);
                file->write((char*)&bSint16, sizeof(short));
            }*/
            file->write((char*)&baseModel->animation[FrameID].cNorm[tot_normals], sizeof(char));
            //file->write((char*)(&bSint32), sizeof(int));
            tot_normals++;
        }
    }
    while (tot_normals%4 !=0)
    {
        file->write((char*)(&bSint32), sizeof(char));
        tot_normals++;
    }

}


void dispAvailableModels(Uint32 meshReorg[], _MOD_DATA * model)
{
    for (unsigned int i=0; i<model->TOTAL_MESH; i++)
    {
        bool Used=false;
        for (unsigned int ii=0; ii<model->TOTAL_MESH; ii++)
            if (meshReorg[ii]==i) Used=true;

        if (Used==false)
            cout << "     Mesh : " << i << ", Name : " << PdataName[i] << "\n";
    }
}
void reOrgModel(_MOD_DATA * model)
{
    if (model->TOTAL_MESH <= 1) return;
    cout << "\n***STEP 6***";
    cout << "\n   You can reoganize your model to allow manual matrix animation.\n";
    cout << "   This will only work with models with multiple meshes.\n";
    cout << "   If you have no idea why you would want this, just skip!\n";
    string ANS;
    cout << "\nDo you want to reorganize your model? Type 'YES' or 'NO'\n\n";
    cin >> ANS;
    cout << "\n\n";
    if (ANS == "YES" || ANS == "Yes" || ANS=="yes")
    {
        cout << "yes.....\n";
        Uint32 meshReorg[model->TOTAL_MESH];
        vPDATA bufModel[model->TOTAL_MESH];
        for (int i=0; i<model->TOTAL_MESH; i++)
        {
            meshReorg[i]={0xFFFFFFFF};
            bufModel[i].nbPoint=0;
            bufModel[i].nbPolygon=0;
            bufModel[i].pntbl=new POINT[model->pol[i].nbPoint];
            bufModel[i].pltbl=new POLYGON[model->pol[i].nbPolygon];
            bufModel[i].attbl=new ATTR[model->pol[i].nbPolygon];
            bufModel[i].vntbl=new VECTOR[model->pol[i].nbPoint];
            vPDATA * curPol=&model->pol[i];
            copyMesh(&bufModel[i], curPol);
            deleteObj(&model->pol[i]);
        }
        Uint32 remainModels=model->TOTAL_MESH;

        while (remainModels>0)
        {
            Uint32 meshCnt=model->TOTAL_MESH-remainModels;
            cout << "\nMesh " << meshCnt << " will be populated by...\n";
            dispAvailableModels(meshReorg, model);
            cout << "Type de number you want to become mesh no." << meshCnt << ".\n";

            Uint32 meshID=0;
            cin >> meshID;
            if (meshID >= model->TOTAL_MESH) {cout << "\nNumber too high!\n"; continue;}
            meshReorg[meshCnt]=meshID;
            model->pol[meshCnt].nbPoint=0;
            model->pol[meshCnt].nbPolygon=0;
            model->pol[meshCnt].pntbl=new POINT[bufModel[meshID].nbPoint];
            model->pol[meshCnt].pltbl=new POLYGON[bufModel[meshID].nbPolygon];
            model->pol[meshCnt].attbl=new ATTR[bufModel[meshID].nbPolygon];
            model->pol[meshCnt].vntbl=new VECTOR[bufModel[meshID].nbPoint];
            copyMesh(&model->pol[meshCnt], &bufModel[meshID]);
            deleteObj(&bufModel[meshID]);

            remainModels--;
        }

    }
    else return;


}

#include <iomanip>
/***** Converts .OBJ files to SGL PDATA, generate collision masks and write to a .ZTM binary file *****/
/**************************
TO DO : CLEAN UP THIS MESS!!!
**************************/
void LoadOBJ(string inFolder, string fileIn, vector3 scalefactor, _MOD_DATA * model)
{
    clearMDATA(model);  //Note that it doesn't overwrite previous textures, only the list. So if your texture folder doesn't contain textures, it will just use last loaded textures
    cout << "Now loading : " << fileIn << "\n";
    string fileInName = inFolder + fileIn + ".obj";
    string fileOutName = "OUT/BIN/" + fileIn;

    ifstream file(fileInName, ios::in | ios::ate);
    if (!file.is_open()) {cout << "ERROR READING OBJ FILE\n"; exit(-1);}

    if (load_OBJ_to_mesh(&file, scalefactor, model, true)) {cout << "\nSuccess : " << fileIn << " loaded...\n";}
    else {cout << "\nERROR : Couldn't load Obj\n"; return;}
    file.close();

    for (int i=0; i<model->TOT_TEXT; i++)    {ReadTGAFile(inFolder, TextureArray[i], i, model);}

    generateMDATA(model);

    cout << "NOW CREATING C FILE (only the 3D model for now)\n";
    string fileOutTXT = "OUT/" + fileIn + ".h";
    write_MOD_HEADER(fileOutTXT, model);
    specialConditions(0, model->TOT_TEXT, model);

    cout << "NOW CREATING BINARY FILE " << fileOutName << ".ZTP\n";
    string binaryFileName = fileOutName + ".ZTP";  //Z-Treme character

    ofstream binFile(binaryFileName.c_str(), ios::out | ios::binary);
    if (!binFile.is_open()) {cout << "\nERROR WHILE WRITING BINARY FILE!\n";}
    else
    {
        if (model->nbFrames==0) reOrgModel(model);
        write_map_to_bin(&binFile, model);

        unsigned int frm=0;
        for (int i=1; i<= (model->nbFrames); )
        {
            _MOD_DATA animModel;
            char s[5];
            sprintf(s, "%06d", i);
            string postVal(s);  //(setfill('0') << setw(5) << i);
            string animName = inFolder + fileIn + "_" + postVal + ".obj";
            cout << animName << "\n\n****************\n";
            //while (1) {}
//cout << setfill('0') << setw(5) << 25;
            ifstream animFile(animName, ios::in | ios::ate);
            if (!animFile.is_open()) {cout << "ERROR READING OBJ FILE\n"; break;}
            if (load_OBJ_to_mesh(&animFile, scalefactor, &animModel, false)) {cout << "\nKeyFrame No. " << i << " loaded...\n";}
            else {cout << "\nERROR : Couldn't load keyframe\n"; break;}
            animFile.close();

            cout << "Comparing animation data with base model...\n";
            compareAnimationData(model, &animModel, frm);
            cout << "Writing animation data to binary file...\n";
            writeAnim(&binFile, model, frm);
            cout << "\nKey frame No." << i << " written to binary file.\n\n";

            for (unsigned int j=0; j<animModel.TOTAL_MESH; j++)
                deleteObj(&animModel.pol[j]);
            frm++;
            i+=(1<<model->framerate);
        }
        binFile.close();
    }

    for (unsigned int i=0; i<model->TOTAL_MESH; i++)
        deleteObj(&model->pol[i]);

/*
    for (unsigned int i=0; i<MAP_DATA.TOTAL_MESH; i++)
    {
        deleteObj(&MainMesh[i]);
    }*/
}



