#ifndef TOOLS_H
#define TOOLS_H

#define toFLOAT(fx)			(((float)(fx)) / 65536.0)
#define MulFX(a, b)	        toFIXED(toFLOAT(a) * toFLOAT(b))
#define slDivFX(a, b)       toFIXED(toFLOAT(a) / toFLOAT(b))
#define toDEG(v)            ((float)(v*360.0f/65536.0f))

unsigned short  swap_endian_ushort(unsigned short value);
short           swap_endian_sshort(short value);
unsigned int    swap_endian_uint(unsigned int value);
int             swap_endian_sint(int value);

int                    AddPoint(vPDATA * newMesh, POINT CurrentPoint);
bool                   CheckPointInBB(vector3 * centerPt, _BB_Hitbox * currentBB);
bool                   CheckPointInBv(vector3 * pt, vector4 * bv);
bool                   CheckSamePlane(POINT TestedPoint, POINT PlanePt2, VECTOR TestedNormal, VECTOR PlaneNormal);
bool                   CheckInFrontPlane(POINT camPt, POINT PlanePt1, VECTOR PlaneNormal);
void                   copyHitbox(_BB_Hitbox * dest, _BB_Hitbox * source);
void                   copyMesh(vPDATA * dest, vPDATA * source);
unsigned int           count_poly_with_bv(vPDATA * pol, vector4 * bv);
unsigned int           countPolygon(vPDATA * originalMesh, _BB_Hitbox * TempMeshBB);
void                   createLocalAABB(vPDATA * orMesh, _BB_Hitbox * currentBB);
void                   VecEdge(float * dest, FIXED fa[3], FIXED fb[3]);
void                   VecNormal(FIXED * dest, float a[3], float b[3] );
void                   VECTOR_NORMAL(vPDATA * pol); //Really need to clean up the names...
int                    ztInnerProduct(VECTOR vct1, VECTOR vct2);
int                    ztInnerProductF(normArr vct1, normArr vct2);

void                   RECALCULATE_NORMALS(vPDATA * pol);
vector3                ReturnBBCenter(_BB_Hitbox * currentBB);
_BB_Hitbox             ReturnPolyBounds(vPDATA * currentMesh, int idx);

bool                   used_textures(unsigned int textID);
void                   mipmap(unsigned int i);
void                   copy_texture_for_mipmap();


#endif // TOOLS_H
