#include "ZTM_DEF.h"
#include <math.h>


bool setColBB (COLLISION * curCol, vPDATA * mesh, int idx)
{
    /**Set condition here for collision*/
    _BB_Hitbox tmpBB = ReturnPolyBounds(mesh, idx);
    vector3 tmpCenter = ReturnBBCenter(&tmpBB);
    curCol->pos.x = tmpCenter.x;
    curCol->pos.y = tmpCenter.y;
    curCol->pos.z = tmpCenter.z;


    curCol->len.x = (tmpBB.MaxValue.x - tmpBB.MinValue.x)/2;
    curCol->len.y = (tmpBB.MaxValue.y - tmpBB.MinValue.y)/2;
    curCol->len.z = (tmpBB.MaxValue.z - tmpBB.MinValue.z)/2;

    curCol->att = TextureSpecialAttribute[mesh->attbl[idx].texno];
    return true;
}



